Bug Hunting Session
Bug 124942 - CRASH - 3D Slide Transitions in Impress
Summary: CRASH - 3D Slide Transitions in Impress
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
6.2.0.3 release
Hardware: x86-64 (AMD64) Mac OS X (All)
: high major
Assignee: Caolán McNamara
URL:
Whiteboard: target:6.3.0 target:6.2.4
Keywords: bibisected, bisected, haveBacktrace, regression
Depends on:
Blocks: Slide-Transitions
  Show dependency treegraph
 
Reported: 2019-04-24 21:39 UTC by Daniele
Modified: 2019-05-26 20:08 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments
Backtrace from lldb session with LODev (11.23 KB, text/plain)
2019-04-25 08:21 UTC, Alex Thurgood
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Daniele 2019-04-24 21:39:47 UTC
Description:
Impress crash particularly if select transition animation. Then the program restart and ask to restore the file. After that, if I try again to add or change a transition animation the app crashes again. This happen with or without acceleration activated. Just to note. Acceleration OpenGL is pointless at this moment in time. If developers from both LO, Collabora etc. want to keep developing Impress on MacOSX they have to adapt to the new (unfortunate) standard for Mac (not sure if it is Metal Api or Vulcan or something like that) because the support for OpenGL on Mac has been dropped long time ago. For all mac users, for now at least, stick with Keynote. 

Steps to Reproduce:
1.Open Impress
2. Go to Transition
3. Select a 3D animation to be applied

Actual Results:
app crashes

Expected Results:
apply the transition and actually displayed it.


Reproducible: Always


User Profile Reset: Yes


OpenGL enabled: Yes

Additional Info:
Comment 1 Alex Thurgood 2019-04-25 07:36:27 UTC
Confirming also on

Version: 6.2.2.2
Build ID: 2b840030fec2aae0fd2658d8d4f9548af4e3518d
Threads CPU : 8; OS : Mac OS X 10.14.3; UI Render : par défaut; VCL: osx; 
Locale : fr-FR (fr_FR.UTF-8); Langue IHM : fr-FR
Calc: threaded

Switching OpenGL on or off makes no difference, LO still crashes as reported.
Comment 2 Alex Thurgood 2019-04-25 07:42:17 UTC
No crash with

Version: 5.1.6.2
Build ID: 07ac168c60a517dba0f0d7bc7540f5afa45f0909
Threads CPU : 8; Version de l'OS :Mac OS X 10.14.3; UI Render : GL; 
Locale : fr-FR (fr_FR.UTF-8); Calc: group

but no 3D transition either, selecting one in the transition preview briefly displays a refresh of the slide. When launching in Slide Show display mode, nothing happens, no transition is shown, but at least no crash.
Comment 3 Alex Thurgood 2019-04-25 07:47:14 UTC
No crash with 

ersion: 4.1.6.2
Build ID: 40ff705089295be5be0aae9b15123f687c05b0a

where the 3D transition effects seem to work correctly, albeit with final position display glitches.
Comment 4 Alex Thurgood 2019-04-25 08:02:17 UTC
The 3D transitions stopped working somewhere between 4.4.x and 5.1.x.

The crashing started in 6.2.x, at least I can reproduce crashing from :

Version: 6.2.0.3
Build ID: 98c6a8a1c6c7b144ce3cc729e34964b47ce25d62
Threads CPU : 8; OS : Mac OS X 10.14.3; UI Render : par défaut; VCL: osx; 
Locale : fr-FR (fr_FR.UTF-8); Langue IHM : fr-FR
Calc: threaded
Comment 5 Alex Thurgood 2019-04-25 08:08:43 UTC
Crash bibisect range :

5.1.x - 6.2.x

FWIW :

5.1.6.2. : no crash (but no 3D transition)
6.2.0.3 : immediate crash, when either selecting the 3D transition in the preview pane, or attempting to play (F5) an existing ODP with a 3D transition saved in it.
Comment 6 Alex Thurgood 2019-04-25 08:15:05 UTC
Running one of my LODev from master in lldb :

1) Loaded ODP into LO
2) F5 to start slideshow

3) lldb output :

Couldn't open libOpenGL.so.0: dlopen(libOpenGL.so.0, 5): image not found
Process 1219 stopped
* thread #1, queue = 'com.apple.main-thread', stop reason = signal SIGABRT
    frame #0: 0x00007fff5db0223e libsystem_kernel.dylib`__pthread_kill + 10
libsystem_kernel.dylib`__pthread_kill:
->  0x7fff5db0223e <+10>: jae    0x7fff5db02248            ; <+20>
    0x7fff5db02240 <+12>: movq   %rax, %rdi
    0x7fff5db02243 <+15>: jmp    0x7fff5dafc3b7            ; cerror_nocancel
    0x7fff5db02248 <+20>: retq   
Target 0: (soffice) stopped.
Comment 7 Alex Thurgood 2019-04-25 08:19:16 UTC
Recovery after the crash without restoring the document causes LO to hide the OSX Dock when the StartCenter is redisplayed. Additionally, the main LO application menu has disappeared.
Comment 8 Alex Thurgood 2019-04-25 08:21:33 UTC
Created attachment 151001 [details]
Backtrace from lldb session with LODev

Enclosing backtrace from lldb session with a fairly recent home built LODev from master.
Comment 9 Alex Thurgood 2019-04-25 08:27:09 UTC
Hmm, let me guess : someone decided to remove inclusion of libOpenGL library in the macOS LO release despite the 3D transition code relying on that library to function ?
Comment 10 Alex Thurgood 2019-04-25 08:34:57 UTC
Or, in order to compile correctly, it has some other Apple "not-invented-here" framework name, or has indeed become deprecated ?
Comment 11 Alex Thurgood 2019-04-25 08:40:11 UTC
Sigh, well my dev build is built on macOS 10.14 and according to this:

https://developer.apple.com/library/archive/documentation/GraphicsImaging/Conceptual/OpenGL-MacProgGuide/opengl_intro/opengl_intro.html

OpenGL is deprecated from macOS 10.14, so take all my findings with a pinch of salt.
Comment 12 Daniele 2019-04-25 14:41:03 UTC
So, as I have mentioned in my post, there should be a specific team that would have to develop on Metal to allow LO on Mac to exploit the hardware acceleration graphics. Unfortunately, I don't think this will happen since this is an open source community. Therefore, while still hoping one day to be able to "fully" use LO on Mac, at the moment the best option, particularly if you have the need to run PPT or PPTX presentations given by 3rd parties, is to use Keynote since it is free and fully compatible with PowerPoint
Comment 13 Julien Nabet 2019-04-25 20:00:28 UTC
(In reply to Daniele from comment #12)
> So, as I have mentioned in my post, there should be a specific team that
> would have to develop on Metal to allow LO on Mac to exploit the hardware
> acceleration graphics. Unfortunately, I don't think this will happen since
> this is an open source community. Therefore, while still hoping one day to
> be able to "fully" use LO on Mac, at the moment the best option,
> particularly if you have the need to run PPT or PPTX presentations given by
> 3rd parties, is to use Keynote since it is free and fully compatible with
> PowerPoint

The problem here isn't the fact that's it's open source community, the problem is Apple decided again to create another standard. Let's see in few years if this tech will be spread or not.
Now I recognize LO is still full of bugs considering the bugtracker and some parts are less taken into account because there are less devs (eg: Mac parts, Base parts).
Comment 14 Xisco Faulí 2019-04-30 06:41:01 UTC
it doesn''t crash for me in

Version: 6.3.0.0.alpha0+
Build ID: ae75372dbdb74eaf959b566f1d9c2b77043e736a
CPU threads: 8; OS: Mac OS X 10.14.2; UI render: GL; VCL: osx; 
Locale: en-US (en_ES.UTF-8); UI-Language: en-US
Calc: threaded

which is the name of the animation crashing for you ?

@Alex, any chance you can bisect this ?
Comment 15 Daniele 2019-04-30 10:26:46 UTC
All the 3D animations don't work (this has been going on since v. 5 of LO). I'm currently running the latest dev version of the software which has fixed the problem with drag and drop causing black screen (different bug of course). Whenever I select to apply a 3d animation (whichever) it crashers. Then once reopened it asks to restore the file but even if I click next nothing happens and the file is lost.
Comment 16 Xisco Faulí 2019-05-02 15:33:44 UTC
I could reproduce it with attachment 137172 [details] from bug 57128

Regression introduced by:

https://cgit.freedesktop.org/libreoffice/core/commit/?id=7d0d1b198e8f87b9a59a584abf71800874f6a431

author	Caolán McNamara <caolanm@redhat.com>	2018-08-27 17:01:15 +0100
committer	Caolán McNamara <caolanm@redhat.com>	2018-08-28 16:32:57 +0200
commit	7d0d1b198e8f87b9a59a584abf71800874f6a431 (patch)
tree	20ccaa25b57e27c631925c8f34b9d4a56026a797
parent	7f3c6efd859050c8f376b6820710e91fa9077ac4 (diff)
upgrade epoxy to 1.5.2

@Caolán, if see  #elif defined(__APPLE__) in epoxy.noglx_means_noglx.patch.1, I guess we still need it ?
Comment 17 Caolán McNamara 2019-05-03 10:59:30 UTC
sounds like https://github.com/anholt/libepoxy/issues/180 (maybe) in which case upgrading to 1.5.3 might solve it
Comment 18 Xisco Faulí 2019-05-03 11:01:00 UTC
(In reply to Caolán McNamara from comment #17)
> sounds like https://github.com/anholt/libepoxy/issues/180 (maybe) in which
> case upgrading to 1.5.3 might solve it

let me check locally...
Comment 19 Caolán McNamara 2019-05-03 11:04:44 UTC
https://gerrit.libreoffice.org/#/c/71733/ is my effort to upgrade our epoxy
Comment 20 Commit Notification 2019-05-03 14:51:25 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/f6e663e4bb725102ebcff03cd0fea5ded9d8bc10%5E%21

Related: tdf#124942 upgrade epoxy to 1.5.3

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 21 Caolán McNamara 2019-05-03 14:51:59 UTC
that reportedly solves it, backport to 6-2 in gerrit
Comment 22 Commit Notification 2019-05-03 19:32:25 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "libreoffice-6-2":

https://git.libreoffice.org/core/+/a20ea8f5999b334c2165e86abb05b5e4805b18c6%5E%21

Related: tdf#124942 upgrade epoxy to 1.5.3

It will be available in 6.2.4.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 23 Xisco Faulí 2019-05-06 15:45:25 UTC
Verified in

Version: 6.3.0.0.alpha0+
Build ID: e575a5e8f89beb3ce1df5a1d83edc0f9d1d8ac43
CPU threads: 8; OS: Mac OS X 10.14.2; UI render: default; VCL: osx; 
Locale: en-US (en_ES.UTF-8); UI-Language: en-US
Calc: threaded

@Caolán, thanks for fixing this issue!!
Comment 24 Daniele 2019-05-26 20:08:54 UTC
My understanding, at this point, is that the 3d transition will never work anymore on macbook. Nevertheless, the crush problem has been fixed. Tested in 6.3.0 alpha and 6.2.4 for MacOsx. Thank you.